from math import sqrt
from random import getrandbits
import pygame
from pygame.locals import *
import os
import png
import operator

time = 0


def step4():    
    global x0, x1,x2,x3,

    global time
    time += 1
    randbits = getrandbits(l)
    # find 2-way on collisions    
    a02 = x0 & x2 & ~x1 & ~x3
    a13 = x1 & x3 & ~x0 & ~x2 

    # find transfers
    c0 = x0 & ~a02
    c1 = x1 & ~a13
    c2 = x2 & ~a02
    c3 = x3 & ~a13

    out0 = a02 | c0
    out1 = a13 | c1
    out2 = a02 | c2
    out3 = a13 | c3

    x0 = rotate_left(out0, 1)
    x1 = rotate_right(out1, w)
    x2 = rotate_left(out2, 1)
    x3 = rotate_left(out3, w)

def step6():    
    global x0, x1,x2,x3,x4,x5

    global time
    time += 1
    #if time%10 == 0:
    #    print time
    #if time%100 == 0:
    #    print x0
    randbits = getrandbits(l)
    # find 2-way on collisions    
    a03 = x0 & x3 & ~x1 & ~x2 & ~x4 & ~x5
    a14 = x1 & x4 & ~x0 & ~x2 & ~x3 & ~x5 
    a25 = x2 & x5 & ~x0 & ~x1 & ~x3 & ~x4

    # decide which way the 2-way collisions will go
    a0314 = a03 & randbits
    a0325 = a03 & ~randbits
    a1403 = a14 & randbits
    a1425 = a14 & ~randbits
    a2503 = a25 & randbits
    a2514 = a25 & ~randbits

    # find 3-way collisions
    b024 = x0 & x2 & x4 & ~x1 & ~x3 & ~x5
    b135 = x1 & x3 & x5 & ~x0 & ~x2 & ~x4

    # find transfers
    c0 = x0 & ~a03 & ~b024
    c1 = x1 & ~a14 & ~b135
    c2 = x2 & ~a25 & ~b024
    c3 = x3 & ~a03 & ~b135
    c4 = x4 & ~a14 & ~b024
    c5 = x5 & ~a25 & ~b135

    out0 = a1403 | a2503 | b024 | c0
    out1 = a0314 | a2514 | b135 | c1
    out2 = a0325 | a1425 | b024 | c2
    out3 = a1403 | a2503 | b135 | c3
    out4 = a0314 | a2514 | b024 | c4
    out5 = a0325 | a1425 | b135 | c5

    x0 = rotate_left(out0, 1)
    x1 = rotate_right(out1, w-1)
    x2 = rotate_right(out2, w)
    x3 = rotate_right(out3, 1)
    x4 = rotate_left(out4, w-1)
    x5 = rotate_left(out5, w)


def rotate_right(x, i):
    mask = 2**i - 1
    carry = x & mask
    slide = x & ~mask
    return (carry << (l-i)) | (slide>>i)

def rotate_left(x, i):
    mask = 2**(l-i) - 1
    carry = x & ~mask
    slide = x & mask
    return (carry >> (l-i)) | (slide<<i)


def getbit(n, i):
    return (n>>i) & 1

def stringize(x):
    bin_str = bin(x)[2:]
    return '0'*(l-len(bin_str)) + bin_str

def draw():
    global srf, x0,x1,x2,x3,x4,x5
    
    if display_direction ==0:
        x= x0
    elif display_direction ==1:
        x= x1
    elif display_direction ==2:
        x= x2
    elif display_direction ==3:
        x= x3
    elif display_direction ==4:
        x= x4
    elif display_direction ==5:
        x= x5
    elif display_direction ==6:
<<<<<<< local
        xstr0 = stringize(x0)
=======
        """xstr0 = stringize(x0)
>>>>>>> other
        xstr1 = stringize(x1)
        xstr2 = stringize(x2)
        xstr3 = stringize(x3)
        xstr4 = stringize(x4)
        xstr5 = stringize(x5)
<<<<<<< local
        y0 = int("".join(reduce(operator.__add__, zip(xstr0, l*'0', l*'0'))), 2)
        y1 = int("".join(reduce(operator.__add__, zip(xstr1, l*'0', l*'0'))), 2)
        y2 = int("".join(reduce(operator.__add__, zip(xstr2, l*'0', l*'0'))), 2)
        y3 = int("".join(reduce(operator.__add__, zip(xstr3, l*'0', l*'0'))), 2)
        y4 = int("".join(reduce(operator.__add__, zip(xstr4, l*'0', l*'0'))), 2)
        y5 = int("".join(reduce(operator.__add__, zip(xstr5, l*'0', l*'0'))), 2)
        x = y0+y1+y2+y3+y4+y5
=======
        y0 = long("".join(reduce(operator.__add__, zip(xstr0, l*'0', l*'0'))), 2)
        y1 = long("".join(reduce(operator.__add__, zip(xstr1, l*'0', l*'0'))), 2)
        y2 = long("".join(reduce(operator.__add__, zip(xstr2, l*'0', l*'0'))), 2)
        y3 = long("".join(reduce(operator.__add__, zip(xstr3, l*'0', l*'0'))), 2)
        y4 = long("".join(reduce(operator.__add__, zip(xstr4, l*'0', l*'0'))), 2)
        y5 = long("".join(reduce(operator.__add__, zip(xstr5, l*'0', l*'0'))), 2)
        x = y0+y1+y2+y3+y4+y5"""
        x=0
        for i in range(l):
           x+= 2**(3*i)*(getbit(x0,i) + getbit(x1,i) + getbit(x2,i) + getbit(x3,i) +  getbit(x4,i) +  getbit(x5,i))
>>>>>>> other

    if display_direction<6:
        bin_str = bin(x)[2:]
        bin_str = '0'*(l-len(bin_str)) + bin_str
    else:
        bin_str = bin(x)[2:]
        bin_str = '0'*(3*l-len(bin_str)) + bin_str
            

    f = open('tmp.png', 'wb')  
    if display_direction==6:
        bd = 3
    else:
        bd = 1
    writ = png.Writer(w, h, bitdepth=bd, greyscale=True)
    writ.write_array(f, bin_str)
    f.close()
    
    """for i in range(l):
        x = i%w
        y = int(i/w)
        d = getbit(x0, i) + getbit(x1, i) + getbit(x2, i) + getbit(x3, i) + getbit(x4, i) + getbit(x5, i)
        
        color = [255*(1-d/7.0), 255*(1-d/7.0), 255*(1-d/7.0)]
        color = [255*d/7, 255*d/7, 255*d/7, 0]
        
        srf.set_at((x,y), color)"""

def bit_sum(x):
    return sum([(x>>y) & 1 for y in range(l-1, -1, -1)])

def repr(x):
    return "".join([str((x>>y) & 1) for y in range(l-1, -1, -1)])


if __name__ == "__main__":
    pygame.init ()

    clock = pygame.time.Clock() 
    h=128
    w=h
    l = w*h
    screen = pygame.display.set_mode ((w + 10, h + 10))
    screen.fill ((250, 250, 250))

    x0 = x1 = x2 = x3 = x4 = x5 = 0
<<<<<<< local
        for y in xrange(h/4, 3*h/4):
            init_row = 2**(y*w + 3*w/4) -  2**(y*w + w/4)
            #raw_input("")
            #print repr(init_row)
            x0 |= init_row
            x1 |= init_row
            x2 |= init_row
            x3 |= init_row
            x4 |= init_row
            x5 |= init_row
=======
    for y in xrange(h/4, 3*h/4):
        init_row = 2**(y*w + 3*w/4) -  2**(y*w + w/4)
        #raw_input("")
        #print repr(init_row)
        x0 |= init_row
        x1 |= init_row
        x2 |= init_row
        x3 |= init_row
        x4 |= init_row
        x5 |= init_row
>>>>>>> other

    srf = pygame.Surface((w, h))
    screen.blit (srf, (5, 5))

    count = 0
    display_direction = 0
    while True:
        if count%1==0:
            draw()
            srf = pygame.image.load(os.path.join('.', 'tmp.png'))
    
            screen.blit (srf, (5, 5))
            pygame.display.flip()   
            """mass = 0
            for x in [x0,x1,x2,x3,x4,x5]:
                mass += bit_sum(x)     """
        count += 1
        for event in pygame.event.get():
            if event.type == QUIT:
                exit()
            if event.type == KEYUP and event.key == K_ESCAPE:
                exit()
            if event.type == KEYUP and event.key == K_SPACE:
                display_direction = (display_direction+1) % 7
        step6()       
        clock.tick_busy_loop(0)

        framerate = clock.get_fps()
        print framerate
        pygame.display.flip()    


